//	app.cpp - Main application stuff.
//	----------------------------------------------------------------------------
//	This file is part of Heilan Front End, a simple simple front end to the
//	Heilan X3D browser.
//	Copyright (c) 2006-2007 Niall Moody.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//	----------------------------------------------------------------------------

#include "juce_amalgamated.h"
#include "app.h"
#include "window.h"

//------------------------------------------------------------------------------
void App::initialise(const String& commandLine)
{
	win = new StupidWindow();
}

//------------------------------------------------------------------------------
void App::shutdown()
{
	delete win;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
StupidWindow::StupidWindow():
DialogWindow(T("Heilan Front End"), Colours::lightblue, false)
{
	setResizable(false, false);
	setContentComponent(mainPanel = new HeilanFrontEnd());
	//mainPanel->setCommandManager(&commandManager);
	centreWithSize(600, 668);
	//setUsingNativeTitleBar(true);
	setVisible(true);
	setMenuBar(mainPanel);

	//commandManager.registerAllCommandsForTarget(mainPanel);
    commandManager.registerAllCommandsForTarget(JUCEApplication::getInstance());
}

//------------------------------------------------------------------------------
StupidWindow::~StupidWindow()
{
	setMenuBar(0);
	setContentComponent(0, true);
}

//------------------------------------------------------------------------------
void StupidWindow::closeButtonPressed()
{
	JUCEApplication::quit();
}

START_JUCE_APPLICATION(App)
