//	app.h - Main application stuff.
//	----------------------------------------------------------------------------
//	This file is part of Heilan Front End, a simple simple front end to the
//	Heilan X3D browser.
//	Copyright (c) 2006-2007 Niall Moody.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//	----------------------------------------------------------------------------

#ifndef APP_H_
#define APP_H_

class HeilanFrontEnd;

///	Handles the main application stuff.
class App : public JUCEApplication
{
  public:
	///	Constructor.
	App() {win = 0;};
	///	Destructor.
	~App() {};

	///	Where all the important stuff happens for this class.
	void initialise(const String& commandLine);
	///	Not used by us?
	void shutdown();

	///	Returns the name of the application (duh...).
	const String getApplicationName() {return T("Heilan Front End");};
	///	Returns the current version.
	const String getApplicationVersion() {return T("0.14");};
	///	Whether or not we want to allow more than one instance to run.
	bool moreThanOneInstanceAllowed() {return true;};
	///	Not used right now?
	void anotherInstanceStarted(const String& commandLine) {};

	///	Returns the main window.
	DialogWindow *getWindow() {return win;};

	juce_UseDebuggingNewOperator
  private:
	///	Pointer to our main window.
	DialogWindow *win;
};

//------------------------------------------------------------------------------
///	Code to receive messages from the close button.
class StupidWindow : public DialogWindow
{
  public:
	///	Constructor.
	StupidWindow();
	///	Constructor.
	~StupidWindow();

	///	To handle the close button being pressed.
	void closeButtonPressed();

	juce_UseDebuggingNewOperator
  private:
	///	The main panel of the main window.
	HeilanFrontEnd *mainPanel;
	///	Used to handle menus and shortcuts etc.
	ApplicationCommandManager commandManager;
};

#endif
