/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  11 Feb 2009 10:48:00 am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.11

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "juce_amalgamated.h"

#include "FileLoader.h"
#include "AboutBox.h"
#include "app.h"

#include "portaudio.h"
#include <iostream>

using namespace std;

#ifndef WIN32
#include <sys/stat.h>
#include <sys/dir.h>
#include <sys/ptrace.h>
//#include <sys/vfs.h>        // for statfs
#include <sys/wait.h>
#include <unistd.h>
#include <fnmatch.h>
#include <utime.h>
#include <pwd.h>
#include <fcntl.h>

// Necessary to avoid terminated child processes becoming zombified
static void sigchild_handler(int sig)
{
	// This is also entered when the child stops
    waitpid(-1, NULL, WNOHANG|WUNTRACED);
}

bool juce_launchFile2 (const String& fileName,
                      const String& parameters)
{
#ifndef __CYGWIN__
    // This won't work if it's a URL
    //static bool childHandlerSetup = false;

    String cmdString (fileName);
    cmdString << " " << parameters;

    //char* const argv[4] = { "/bin/sh", "-c", (char*) (const char*) cmdString, 0 };

	pid_t pid = fork();

	switch(pid)
	{
		case 0: //Child process - successful.
			setsid();
			execlp("/bin/sh", "sh", "-c", (char*) (const char*) cmdString, NULL);
			//Only get to this point if execlp didn't work.
			exit(1);
			break;
		case -1: //Parent process - unsuccessful.
			return false;
			break;
		default: //Parent process - successful.
			break;
	}
	return true;

    /*if (childHandlerSetup == false)
    {
        struct sigaction saction;
        sigset_t maskSet;
        sigemptyset (&maskSet);
        saction.sa_handler = sigchild_handler;
        saction.sa_mask = maskSet;
        saction.sa_flags = 0;
        sigaction (SIGCLD, &saction, 0);
        childHandlerSetup = true;
    }

    const int cpid = fork();

    if (cpid == 0)
    {
		setsid();
        // Child process
        ptrace (PTRACE_TRACEME, 0, 0, 0);

        if (execve (argv[0], argv, environ) < 0)
            exit (0);
    }
    else
    {
        if (cpid < 0)
            return false;

        // Wait for child process
        int status;
        waitpid (cpid, &status, WUNTRACED);

        if (WIFSTOPPED (status))
        {
            // Child process stopped at SIGTRAP caused by
            // successful execve, now let it continue
            ptrace (PTRACE_DETACH, cpid, 0, 0);
        }
        else
        {
            // Child process exited, meaning execve failed
            return false;
        }
    }

    return true;*/
#else
    jassertfalse // cygwin doesn't seem to have the headers for doing this..
    return false;
#endif
}
#endif

//[/Headers]

#include "window.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
HeilanFrontEnd::HeilanFrontEnd ()
    : Component (T("Heilan Front End")),
      windowWidth (0),
      widthLabel (0),
      graphicsLabel (0),
      windowHeight (0),
      heightLabel (0),
      antialiasOff (0),
      antialiasLabel (0),
      antialias2x (0),
      antialias4x (0),
      antialias6x (0),
      fullscreenButton (0),
      audioLabel (0),
      apiLabel (0),
      audioApi (0),
      deviceLabel (0),
      audioDevice (0),
      blockSizeLabel (0),
      audioBlockSize (0),
      samplerateLabel (0),
      audioSamplerate (0),
      speakerLabel (0),
      audioSpeakerConfig (0),
      oscLabel (0),
      oscPort (0),
      disableSound (0),
      disableOsc (0),
      x3dLabel (0),
      loadFile (0),
      browserPath (0),
      loadPath (0),
      goButton (0),
      libsLabel (0),
      libraryList (0),
      addLibrary (0),
      removeLibrary (0),
      offlineRender (0),
      recordOscLabel (0),
      recordOscPath (0),
      recordOscLoad (0),
      fileToLoad (0),
      bloomFilter (0),
      enableCursor (0),
      customConfigPath (0),
      loadConfig (0),
      speakerLabel2 (0),
      oscLabel2 (0),
      oscInputLabel (0),
      oscInputAddress (0),
      oscOPPortLabel (0),
      oscOPPort (0),
      oscOPLabel (0),
      oscOPAddress (0),
      browserPathLabel (0),
      browserPathLabel2 (0),
      inputDeviceLabel (0),
      audioInputDevice (0)
{
    addAndMakeVisible (windowWidth = new TextEditor (T("Window Width")));
    windowWidth->setMultiLine (false);
    windowWidth->setReturnKeyStartsNewLine (false);
    windowWidth->setReadOnly (false);
    windowWidth->setScrollbarsShown (true);
    windowWidth->setCaretVisible (true);
    windowWidth->setPopupMenuEnabled (true);
    windowWidth->setColour (TextEditor::textColourId, Colours::black);
    windowWidth->setColour (TextEditor::backgroundColourId, Colours::white);
    windowWidth->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    windowWidth->setColour (TextEditor::outlineColourId, Colour (0x0));
    windowWidth->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    windowWidth->setColour (TextEditor::caretColourId, Colours::black);
    windowWidth->setText (T("640"));

    addAndMakeVisible (widthLabel = new Label (T("new label"),
                                               T("Window Width:")));
    widthLabel->setFont (Font (15.0000f, Font::plain));
    widthLabel->setJustificationType (Justification::centredLeft);
    widthLabel->setEditable (false, false, false);
    widthLabel->setColour (Label::backgroundColourId, Colour (0x0));
    widthLabel->setColour (Label::textColourId, Colours::black);
    widthLabel->setColour (Label::outlineColourId, Colour (0x0));
    widthLabel->setColour (TextEditor::textColourId, Colours::black);
    widthLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    widthLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (graphicsLabel = new Label (T("new label"),
                                                  T("Graphics Options")));
    graphicsLabel->setFont (Font (15.0000f, Font::bold));
    graphicsLabel->setJustificationType (Justification::centredLeft);
    graphicsLabel->setEditable (false, false, false);
    graphicsLabel->setColour (Label::backgroundColourId, Colour (0x0));
    graphicsLabel->setColour (Label::textColourId, Colours::black);
    graphicsLabel->setColour (Label::outlineColourId, Colour (0x0));
    graphicsLabel->setColour (TextEditor::textColourId, Colours::black);
    graphicsLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    graphicsLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (windowHeight = new TextEditor (T("Window Height")));
    windowHeight->setMultiLine (false);
    windowHeight->setReturnKeyStartsNewLine (false);
    windowHeight->setReadOnly (false);
    windowHeight->setScrollbarsShown (true);
    windowHeight->setCaretVisible (true);
    windowHeight->setPopupMenuEnabled (true);
    windowHeight->setColour (TextEditor::textColourId, Colours::black);
    windowHeight->setColour (TextEditor::backgroundColourId, Colours::white);
    windowHeight->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    windowHeight->setColour (TextEditor::outlineColourId, Colour (0x0));
    windowHeight->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    windowHeight->setColour (TextEditor::caretColourId, Colours::black);
    windowHeight->setText (T("480"));

    addAndMakeVisible (heightLabel = new Label (T("new label"),
                                                T("Window Height:")));
    heightLabel->setFont (Font (15.0000f, Font::plain));
    heightLabel->setJustificationType (Justification::centredLeft);
    heightLabel->setEditable (false, false, false);
    heightLabel->setColour (Label::backgroundColourId, Colour (0x0));
    heightLabel->setColour (Label::textColourId, Colours::black);
    heightLabel->setColour (Label::outlineColourId, Colour (0x0));
    heightLabel->setColour (TextEditor::textColourId, Colours::black);
    heightLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    heightLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (antialiasOff = new TextButton (T("off")));
    antialiasOff->setConnectedEdges (Button::ConnectedOnRight);
    antialiasOff->addButtonListener (this);
    antialiasOff->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    antialiasOff->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    antialiasOff->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (antialiasLabel = new Label (T("new label"),
                                                   T("Antialiasing:")));
    antialiasLabel->setFont (Font (15.0000f, Font::plain));
    antialiasLabel->setJustificationType (Justification::centredLeft);
    antialiasLabel->setEditable (false, false, false);
    antialiasLabel->setColour (Label::backgroundColourId, Colour (0x0));
    antialiasLabel->setColour (Label::textColourId, Colours::black);
    antialiasLabel->setColour (Label::outlineColourId, Colour (0x0));
    antialiasLabel->setColour (TextEditor::textColourId, Colours::black);
    antialiasLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    antialiasLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (antialias2x = new TextButton (T("2x")));
    antialias2x->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    antialias2x->addButtonListener (this);
    antialias2x->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    antialias2x->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    antialias2x->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (antialias4x = new TextButton (T("4x")));
    antialias4x->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    antialias4x->addButtonListener (this);
    antialias4x->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    antialias4x->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    antialias4x->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (antialias6x = new TextButton (T("6x")));
    antialias6x->setConnectedEdges (Button::ConnectedOnLeft);
    antialias6x->addButtonListener (this);
    antialias6x->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    antialias6x->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    antialias6x->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (fullscreenButton = new ToggleButton (T("Fullscreen")));
    fullscreenButton->addButtonListener (this);

    addAndMakeVisible (audioLabel = new Label (T("new label"),
                                               T("Audio Options")));
    audioLabel->setFont (Font (15.0000f, Font::bold));
    audioLabel->setJustificationType (Justification::centredLeft);
    audioLabel->setEditable (false, false, false);
    audioLabel->setColour (Label::backgroundColourId, Colour (0x0));
    audioLabel->setColour (Label::textColourId, Colours::black);
    audioLabel->setColour (Label::outlineColourId, Colour (0x0));
    audioLabel->setColour (TextEditor::textColourId, Colours::black);
    audioLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    audioLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (apiLabel = new Label (T("new label"),
                                             T("Audio API:")));
    apiLabel->setFont (Font (15.0000f, Font::plain));
    apiLabel->setJustificationType (Justification::centredLeft);
    apiLabel->setEditable (false, false, false);
    apiLabel->setColour (Label::backgroundColourId, Colour (0x0));
    apiLabel->setColour (Label::textColourId, Colours::black);
    apiLabel->setColour (Label::outlineColourId, Colour (0x0));
    apiLabel->setColour (TextEditor::textColourId, Colours::black);
    apiLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    apiLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioApi = new ComboBox (T("new combo box")));
    audioApi->setEditableText (false);
    audioApi->setJustificationType (Justification::centredLeft);
    audioApi->setTextWhenNothingSelected (String::empty);
    audioApi->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioApi->addListener (this);

    addAndMakeVisible (deviceLabel = new Label (T("new label"),
                                                T("Output Device:")));
    deviceLabel->setFont (Font (15.0000f, Font::plain));
    deviceLabel->setJustificationType (Justification::centredLeft);
    deviceLabel->setEditable (false, false, false);
    deviceLabel->setColour (Label::backgroundColourId, Colour (0x0));
    deviceLabel->setColour (Label::textColourId, Colours::black);
    deviceLabel->setColour (Label::outlineColourId, Colour (0x0));
    deviceLabel->setColour (TextEditor::textColourId, Colours::black);
    deviceLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    deviceLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioDevice = new ComboBox (T("new combo box")));
    audioDevice->setEditableText (false);
    audioDevice->setJustificationType (Justification::centredLeft);
    audioDevice->setTextWhenNothingSelected (String::empty);
    audioDevice->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioDevice->addListener (this);

    addAndMakeVisible (blockSizeLabel = new Label (T("new label"),
                                                   T("Block Size:")));
    blockSizeLabel->setFont (Font (15.0000f, Font::plain));
    blockSizeLabel->setJustificationType (Justification::centredLeft);
    blockSizeLabel->setEditable (false, false, false);
    blockSizeLabel->setColour (Label::backgroundColourId, Colour (0x0));
    blockSizeLabel->setColour (Label::textColourId, Colours::black);
    blockSizeLabel->setColour (Label::outlineColourId, Colour (0x0));
    blockSizeLabel->setColour (TextEditor::textColourId, Colours::black);
    blockSizeLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    blockSizeLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioBlockSize = new ComboBox (T("new combo box")));
    audioBlockSize->setEditableText (false);
    audioBlockSize->setJustificationType (Justification::centredLeft);
    audioBlockSize->setTextWhenNothingSelected (String::empty);
    audioBlockSize->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioBlockSize->addItem (T("default"), 1);
    audioBlockSize->addListener (this);

    addAndMakeVisible (samplerateLabel = new Label (T("new label"),
                                                    T("Samplerate:")));
    samplerateLabel->setFont (Font (15.0000f, Font::plain));
    samplerateLabel->setJustificationType (Justification::centredLeft);
    samplerateLabel->setEditable (false, false, false);
    samplerateLabel->setColour (Label::backgroundColourId, Colour (0x0));
    samplerateLabel->setColour (Label::textColourId, Colours::black);
    samplerateLabel->setColour (Label::outlineColourId, Colour (0x0));
    samplerateLabel->setColour (TextEditor::textColourId, Colours::black);
    samplerateLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    samplerateLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioSamplerate = new ComboBox (T("new combo box")));
    audioSamplerate->setEditableText (false);
    audioSamplerate->setJustificationType (Justification::centredLeft);
    audioSamplerate->setTextWhenNothingSelected (String::empty);
    audioSamplerate->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioSamplerate->addItem (T("44100"), 1);
    audioSamplerate->addItem (T("48000"), 2);
    audioSamplerate->addItem (T("96000"), 3);
    audioSamplerate->addItem (T("192000"), 4);
    audioSamplerate->addListener (this);

    addAndMakeVisible (speakerLabel = new Label (T("new label"),
                                                 T("Speaker\nConfiguration:")));
    speakerLabel->setFont (Font (15.0000f, Font::plain));
    speakerLabel->setJustificationType (Justification::centredLeft);
    speakerLabel->setEditable (false, false, false);
    speakerLabel->setColour (Label::backgroundColourId, Colour (0x0));
    speakerLabel->setColour (Label::textColourId, Colours::black);
    speakerLabel->setColour (Label::outlineColourId, Colour (0x0));
    speakerLabel->setColour (TextEditor::textColourId, Colours::black);
    speakerLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    speakerLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioSpeakerConfig = new ComboBox (T("new combo box")));
    audioSpeakerConfig->setEditableText (false);
    audioSpeakerConfig->setJustificationType (Justification::centredLeft);
    audioSpeakerConfig->setTextWhenNothingSelected (String::empty);
    audioSpeakerConfig->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioSpeakerConfig->addItem (T("Mono"), 1);
    audioSpeakerConfig->addItem (T("Stereo"), 2);
    audioSpeakerConfig->addItem (T("Square"), 3);
    audioSpeakerConfig->addItem (T("Pentagon"), 4);
    audioSpeakerConfig->addItem (T("Hexagon"), 5);
    audioSpeakerConfig->addItem (T("Octagon1"), 6);
    audioSpeakerConfig->addItem (T("Octagon2"), 7);
    audioSpeakerConfig->addItem (T("Surround1"), 8);
    audioSpeakerConfig->addItem (T("Cube"), 9);
    audioSpeakerConfig->addItem (T("Dodecahedron1"), 10);
    audioSpeakerConfig->addItem (T("Dodecahedron2"), 11);
    audioSpeakerConfig->addItem (T("Components"), 12);
    audioSpeakerConfig->addItem (T("Custom"), 13);
    audioSpeakerConfig->addListener (this);

    addAndMakeVisible (oscLabel = new Label (T("new label"),
                                             T("Input Port:")));
    oscLabel->setFont (Font (15.0000f, Font::plain));
    oscLabel->setJustificationType (Justification::centredLeft);
    oscLabel->setEditable (false, false, false);
    oscLabel->setColour (Label::backgroundColourId, Colour (0x0));
    oscLabel->setColour (Label::textColourId, Colours::black);
    oscLabel->setColour (Label::outlineColourId, Colour (0x0));
    oscLabel->setColour (TextEditor::textColourId, Colours::black);
    oscLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    oscLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (oscPort = new TextEditor (T("OSC Port")));
    oscPort->setMultiLine (false);
    oscPort->setReturnKeyStartsNewLine (false);
    oscPort->setReadOnly (false);
    oscPort->setScrollbarsShown (true);
    oscPort->setCaretVisible (true);
    oscPort->setPopupMenuEnabled (true);
    oscPort->setColour (TextEditor::textColourId, Colours::black);
    oscPort->setColour (TextEditor::backgroundColourId, Colours::white);
    oscPort->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    oscPort->setColour (TextEditor::outlineColourId, Colour (0x0));
    oscPort->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    oscPort->setColour (TextEditor::caretColourId, Colours::black);
    oscPort->setText (T("5678"));

    addAndMakeVisible (disableSound = new ToggleButton (T("Disable Sound")));
    disableSound->addButtonListener (this);

    addAndMakeVisible (disableOsc = new ToggleButton (T("Disable OSC")));
    disableOsc->addButtonListener (this);

    addAndMakeVisible (x3dLabel = new Label (T("new label"),
                                             T("X3D File")));
    x3dLabel->setFont (Font (15.0000f, Font::bold));
    x3dLabel->setJustificationType (Justification::centredLeft);
    x3dLabel->setEditable (false, false, false);
    x3dLabel->setColour (Label::backgroundColourId, Colour (0x0));
    x3dLabel->setColour (Label::textColourId, Colours::black);
    x3dLabel->setColour (Label::outlineColourId, Colour (0x0));
    x3dLabel->setColour (TextEditor::textColourId, Colours::black);
    x3dLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    x3dLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (loadFile = new TextButton (T("...")));
    loadFile->setConnectedEdges (Button::ConnectedOnLeft);
    loadFile->addButtonListener (this);
    loadFile->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    loadFile->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    loadFile->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (browserPath = new TextEditor (T("new text editor")));
    browserPath->setMultiLine (false);
    browserPath->setReturnKeyStartsNewLine (false);
    browserPath->setReadOnly (false);
    browserPath->setScrollbarsShown (true);
    browserPath->setCaretVisible (true);
    browserPath->setPopupMenuEnabled (true);
    browserPath->setColour (TextEditor::textColourId, Colours::black);
    browserPath->setColour (TextEditor::backgroundColourId, Colours::white);
    browserPath->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    browserPath->setColour (TextEditor::outlineColourId, Colour (0x0));
    browserPath->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    browserPath->setColour (TextEditor::caretColourId, Colours::black);
    browserPath->setText (String::empty);

    addAndMakeVisible (loadPath = new TextButton (T("...")));
    loadPath->addButtonListener (this);
    loadPath->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    loadPath->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    loadPath->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (goButton = new TextButton (T("go")));
    goButton->setButtonText (T("Go"));
    goButton->addButtonListener (this);
    goButton->setColour (TextButton::buttonColourId, Colour (0xff00a60f));
    goButton->setColour (TextButton::buttonOnColourId, Colour (0xff096f12));
    goButton->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (libsLabel = new Label (T("new label"),
                                              T("Libraries:")));
    libsLabel->setFont (Font (15.0000f, Font::plain));
    libsLabel->setJustificationType (Justification::centredLeft);
    libsLabel->setEditable (false, false, false);
    libsLabel->setColour (Label::backgroundColourId, Colour (0x0));
    libsLabel->setColour (Label::textColourId, Colours::black);
    libsLabel->setColour (Label::outlineColourId, Colour (0x0));
    libsLabel->setColour (TextEditor::textColourId, Colours::black);
    libsLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    libsLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (libraryList = new ListBox (T("Library List"), this));
    libraryList->setName (T("Library List"));

    addAndMakeVisible (addLibrary = new TextButton (T("Add Library Button")));
    addLibrary->setButtonText (T("+"));
    addLibrary->addButtonListener (this);
    addLibrary->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    addLibrary->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    addLibrary->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (removeLibrary = new TextButton (T("Remove Library Button")));
    removeLibrary->setButtonText (T("-"));
    removeLibrary->addButtonListener (this);
    removeLibrary->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    removeLibrary->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    removeLibrary->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (offlineRender = new TextButton (T("Offline")));
    offlineRender->addButtonListener (this);
    offlineRender->setColour (TextButton::buttonColourId, Colour (0xffff4747));
    offlineRender->setColour (TextButton::buttonOnColourId, Colour (0xff9e2a2a));

    addAndMakeVisible (recordOscLabel = new Label (T("recordOscLabel"),
                                                   T("Record OSC to:")));
    recordOscLabel->setFont (Font (15.0000f, Font::plain));
    recordOscLabel->setJustificationType (Justification::centredLeft);
    recordOscLabel->setEditable (false, false, false);
    recordOscLabel->setColour (Label::backgroundColourId, Colour (0x0));
    recordOscLabel->setColour (Label::textColourId, Colours::black);
    recordOscLabel->setColour (Label::outlineColourId, Colour (0x0));
    recordOscLabel->setColour (TextEditor::textColourId, Colours::black);
    recordOscLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    recordOscLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (recordOscPath = new TextEditor (T("recordOscPath")));
    recordOscPath->setMultiLine (false);
    recordOscPath->setReturnKeyStartsNewLine (false);
    recordOscPath->setReadOnly (false);
    recordOscPath->setScrollbarsShown (true);
    recordOscPath->setCaretVisible (true);
    recordOscPath->setPopupMenuEnabled (true);
    recordOscPath->setColour (TextEditor::textColourId, Colours::black);
    recordOscPath->setColour (TextEditor::backgroundColourId, Colours::white);
    recordOscPath->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    recordOscPath->setColour (TextEditor::outlineColourId, Colour (0x0));
    recordOscPath->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    recordOscPath->setColour (TextEditor::caretColourId, Colours::black);
    recordOscPath->setText (String::empty);

    addAndMakeVisible (recordOscLoad = new TextButton (T("...")));
    recordOscLoad->addButtonListener (this);
    recordOscLoad->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    recordOscLoad->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    recordOscLoad->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (fileToLoad = new ComboBox (T("new combo box")));
    fileToLoad->setEditableText (true);
    fileToLoad->setJustificationType (Justification::centredLeft);
    fileToLoad->setTextWhenNothingSelected (String::empty);
    fileToLoad->setTextWhenNoChoicesAvailable (T("(no choices)"));
    fileToLoad->addListener (this);

    addAndMakeVisible (bloomFilter = new ToggleButton (T("bloomFilter")));
    bloomFilter->setButtonText (T("Bloom Filter"));
    bloomFilter->addButtonListener (this);

    addAndMakeVisible (enableCursor = new ToggleButton (T("Enable Cursor")));
    enableCursor->addButtonListener (this);

    addAndMakeVisible (customConfigPath = new TextEditor (T("new text editor")));
    customConfigPath->setMultiLine (false);
    customConfigPath->setReturnKeyStartsNewLine (false);
    customConfigPath->setReadOnly (false);
    customConfigPath->setScrollbarsShown (true);
    customConfigPath->setCaretVisible (true);
    customConfigPath->setPopupMenuEnabled (true);
    customConfigPath->setColour (TextEditor::textColourId, Colours::black);
    customConfigPath->setColour (TextEditor::backgroundColourId, Colours::white);
    customConfigPath->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    customConfigPath->setColour (TextEditor::outlineColourId, Colour (0x0));
    customConfigPath->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    customConfigPath->setColour (TextEditor::caretColourId, Colours::black);
    customConfigPath->setText (String::empty);

    addAndMakeVisible (loadConfig = new TextButton (T("...")));
    loadConfig->addButtonListener (this);
    loadConfig->setColour (TextButton::buttonColourId, Colour (0xffbbbbff));
    loadConfig->setColour (TextButton::buttonOnColourId, Colour (0xff4444ff));
    loadConfig->setColour (TextButton::textColourId, Colours::black);

    addAndMakeVisible (speakerLabel2 = new Label (T("new label"),
                                                  T("Speaker Config File:")));
    speakerLabel2->setFont (Font (15.0000f, Font::plain));
    speakerLabel2->setJustificationType (Justification::centredLeft);
    speakerLabel2->setEditable (false, false, false);
    speakerLabel2->setColour (Label::backgroundColourId, Colour (0x0));
    speakerLabel2->setColour (Label::textColourId, Colours::black);
    speakerLabel2->setColour (Label::outlineColourId, Colour (0x0));
    speakerLabel2->setColour (TextEditor::textColourId, Colours::black);
    speakerLabel2->setColour (TextEditor::backgroundColourId, Colour (0x0));
    speakerLabel2->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (oscLabel2 = new Label (T("new label"),
                                              T("OSC Options")));
    oscLabel2->setFont (Font (15.0000f, Font::bold));
    oscLabel2->setJustificationType (Justification::centredLeft);
    oscLabel2->setEditable (false, false, false);
    oscLabel2->setColour (Label::backgroundColourId, Colour (0x0));
    oscLabel2->setColour (Label::textColourId, Colours::black);
    oscLabel2->setColour (Label::outlineColourId, Colour (0x0));
    oscLabel2->setColour (TextEditor::textColourId, Colours::black);
    oscLabel2->setColour (TextEditor::backgroundColourId, Colour (0x0));
    oscLabel2->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (oscInputLabel = new Label (T("new label"),
                                                  T("Multicast Input Address:")));
    oscInputLabel->setFont (Font (15.0000f, Font::plain));
    oscInputLabel->setJustificationType (Justification::centredLeft);
    oscInputLabel->setEditable (false, false, false);
    oscInputLabel->setColour (TextEditor::textColourId, Colours::black);
    oscInputLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (oscInputAddress = new TextEditor (T("new text editor")));
    oscInputAddress->setMultiLine (false);
    oscInputAddress->setReturnKeyStartsNewLine (false);
    oscInputAddress->setReadOnly (false);
    oscInputAddress->setScrollbarsShown (true);
    oscInputAddress->setCaretVisible (true);
    oscInputAddress->setPopupMenuEnabled (true);
    oscInputAddress->setText (String::empty);

    addAndMakeVisible (oscOPPortLabel = new Label (T("new label"),
                                                   T("Output Port:")));
    oscOPPortLabel->setFont (Font (15.0000f, Font::plain));
    oscOPPortLabel->setJustificationType (Justification::centredLeft);
    oscOPPortLabel->setEditable (false, false, false);
    oscOPPortLabel->setColour (Label::backgroundColourId, Colour (0x0));
    oscOPPortLabel->setColour (Label::textColourId, Colours::black);
    oscOPPortLabel->setColour (Label::outlineColourId, Colour (0x0));
    oscOPPortLabel->setColour (TextEditor::textColourId, Colours::black);
    oscOPPortLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    oscOPPortLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (oscOPPort = new TextEditor (T("OSC Port")));
    oscOPPort->setMultiLine (false);
    oscOPPort->setReturnKeyStartsNewLine (false);
    oscOPPort->setReadOnly (false);
    oscOPPort->setScrollbarsShown (true);
    oscOPPort->setCaretVisible (true);
    oscOPPort->setPopupMenuEnabled (true);
    oscOPPort->setColour (TextEditor::textColourId, Colours::black);
    oscOPPort->setColour (TextEditor::backgroundColourId, Colours::white);
    oscOPPort->setColour (TextEditor::highlightColourId, Colour (0x401111ee));
    oscOPPort->setColour (TextEditor::outlineColourId, Colour (0x0));
    oscOPPort->setColour (TextEditor::shadowColourId, Colour (0x38000000));
    oscOPPort->setColour (TextEditor::caretColourId, Colours::black);
    oscOPPort->setText (T("5679"));

    addAndMakeVisible (oscOPLabel = new Label (T("new label"),
                                               T("Output Address:")));
    oscOPLabel->setFont (Font (15.0000f, Font::plain));
    oscOPLabel->setJustificationType (Justification::centredLeft);
    oscOPLabel->setEditable (false, false, false);
    oscOPLabel->setColour (TextEditor::textColourId, Colours::black);
    oscOPLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (oscOPAddress = new TextEditor (T("new text editor")));
    oscOPAddress->setMultiLine (false);
    oscOPAddress->setReturnKeyStartsNewLine (false);
    oscOPAddress->setReadOnly (false);
    oscOPAddress->setScrollbarsShown (true);
    oscOPAddress->setCaretVisible (true);
    oscOPAddress->setPopupMenuEnabled (true);
    oscOPAddress->setText (String::empty);

    addAndMakeVisible (browserPathLabel = new Label (T("new label"),
                                                     T("Files")));
    browserPathLabel->setFont (Font (15.0000f, Font::bold));
    browserPathLabel->setJustificationType (Justification::centredLeft);
    browserPathLabel->setEditable (false, false, false);
    browserPathLabel->setColour (Label::backgroundColourId, Colour (0x0));
    browserPathLabel->setColour (Label::textColourId, Colours::black);
    browserPathLabel->setColour (Label::outlineColourId, Colour (0x0));
    browserPathLabel->setColour (TextEditor::textColourId, Colours::black);
    browserPathLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    browserPathLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (browserPathLabel2 = new Label (T("new label"),
                                                      T("Browser Path:")));
    browserPathLabel2->setFont (Font (15.0000f, Font::plain));
    browserPathLabel2->setJustificationType (Justification::centredLeft);
    browserPathLabel2->setEditable (false, false, false);
    browserPathLabel2->setColour (TextEditor::textColourId, Colours::black);
    browserPathLabel2->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (inputDeviceLabel = new Label (T("new label"),
                                                     T("Input Device:")));
    inputDeviceLabel->setFont (Font (15.0000f, Font::plain));
    inputDeviceLabel->setJustificationType (Justification::centredLeft);
    inputDeviceLabel->setEditable (false, false, false);
    inputDeviceLabel->setColour (Label::backgroundColourId, Colour (0x0));
    inputDeviceLabel->setColour (Label::textColourId, Colours::black);
    inputDeviceLabel->setColour (Label::outlineColourId, Colour (0x0));
    inputDeviceLabel->setColour (TextEditor::textColourId, Colours::black);
    inputDeviceLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));
    inputDeviceLabel->setColour (TextEditor::highlightColourId, Colour (0x401111ee));

    addAndMakeVisible (audioInputDevice = new ComboBox (T("new combo box")));
    audioInputDevice->setEditableText (false);
    audioInputDevice->setJustificationType (Justification::centredLeft);
    audioInputDevice->setTextWhenNothingSelected (String::empty);
    audioInputDevice->setTextWhenNoChoicesAvailable (T("(no choices)"));
    audioInputDevice->addListener (this);


    //[UserPreSize]
    //[/UserPreSize]

    setSize (600, 616);

    //[Constructor] You can add your own custom stuff here..
	int i;

	customConfigPath->setEnabled(false);
	loadConfig->setEnabled(false);

	antialiasOff->setClickingTogglesState(true);
	antialiasOff->setRadioGroupId(SlotId);
	antialias2x->setClickingTogglesState(true);
	antialias2x->setRadioGroupId(SlotId);
	antialias4x->setClickingTogglesState(true);
	antialias4x->setRadioGroupId(SlotId);
	antialias6x->setClickingTogglesState(true);
	antialias6x->setRadioGroupId(SlotId);
	antialiasOff->setToggleState(true, false);

	if(Pa_Initialize() == paNoError)
	{
		for(i=0;i<Pa_GetHostApiCount();++i)
		{
			const PaHostApiInfo *apiInfo = Pa_GetHostApiInfo(static_cast<PaHostApiIndex>(i));
			audioApi->addItem(apiInfo->name, (i+1));
		}
		if(Pa_GetHostApiCount() > 0)
			audioApi->setSelectedId(1);
		Pa_Terminate();
	}

	loader = new FileLoader(this);

	offlineSamples = T("1");

	//Initialise lastX3DFile to this directory.
	lastX3DFile = File::getCurrentWorkingDirectory();

#ifndef WIN32
	struct sigaction act;
    sigset_t maskSet;
	//XSetWindowAttributes att;

	//Set up a handler so that zombie processes get killed.
	sigemptyset(&maskSet);
	act.sa_handler = sigchild_handler;
	act.sa_mask = maskSet;
	act.sa_flags = 0;
	sigaction(SIGCHLD, &act, NULL);
#endif
    //[/Constructor]
}

HeilanFrontEnd::~HeilanFrontEnd()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    deleteAndZero (windowWidth);
    deleteAndZero (widthLabel);
    deleteAndZero (graphicsLabel);
    deleteAndZero (windowHeight);
    deleteAndZero (heightLabel);
    deleteAndZero (antialiasOff);
    deleteAndZero (antialiasLabel);
    deleteAndZero (antialias2x);
    deleteAndZero (antialias4x);
    deleteAndZero (antialias6x);
    deleteAndZero (fullscreenButton);
    deleteAndZero (audioLabel);
    deleteAndZero (apiLabel);
    deleteAndZero (audioApi);
    deleteAndZero (deviceLabel);
    deleteAndZero (audioDevice);
    deleteAndZero (blockSizeLabel);
    deleteAndZero (audioBlockSize);
    deleteAndZero (samplerateLabel);
    deleteAndZero (audioSamplerate);
    deleteAndZero (speakerLabel);
    deleteAndZero (audioSpeakerConfig);
    deleteAndZero (oscLabel);
    deleteAndZero (oscPort);
    deleteAndZero (disableSound);
    deleteAndZero (disableOsc);
    deleteAndZero (x3dLabel);
    deleteAndZero (loadFile);
    deleteAndZero (browserPath);
    deleteAndZero (loadPath);
    deleteAndZero (goButton);
    deleteAndZero (libsLabel);
    deleteAndZero (libraryList);
    deleteAndZero (addLibrary);
    deleteAndZero (removeLibrary);
    deleteAndZero (offlineRender);
    deleteAndZero (recordOscLabel);
    deleteAndZero (recordOscPath);
    deleteAndZero (recordOscLoad);
    deleteAndZero (fileToLoad);
    deleteAndZero (bloomFilter);
    deleteAndZero (enableCursor);
    deleteAndZero (customConfigPath);
    deleteAndZero (loadConfig);
    deleteAndZero (speakerLabel2);
    deleteAndZero (oscLabel2);
    deleteAndZero (oscInputLabel);
    deleteAndZero (oscInputAddress);
    deleteAndZero (oscOPPortLabel);
    deleteAndZero (oscOPPort);
    deleteAndZero (oscOPLabel);
    deleteAndZero (oscOPAddress);
    deleteAndZero (browserPathLabel);
    deleteAndZero (browserPathLabel2);
    deleteAndZero (inputDeviceLabel);
    deleteAndZero (audioInputDevice);

    //[Destructor]. You can add your own custom destruction code here..
	delete loader;
    //[/Destructor]
}

//==============================================================================
void HeilanFrontEnd::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::lightblue);

    g.setColour (Colours::black);
    g.fillRect (8, 96, 584, 1);

    g.setColour (Colours::black);
    g.fillRect (8, 264, 584, 1);

    g.setColour (Colours::black);
    g.fillRect (8, 400, 584, 1);

    g.setColour (Colours::black);
    g.fillRect (8, 545, 584, 1);

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void HeilanFrontEnd::resized()
{
    windowWidth->setBounds (120, 32, 48, 24);
    widthLabel->setBounds (16, 32, 104, 24);
    graphicsLabel->setBounds (8, 0, 150, 24);
    windowHeight->setBounds (120, 64, 48, 24);
    heightLabel->setBounds (16, 64, 104, 24);
    antialiasOff->setBounds (296, 32, 48, 24);
    antialiasLabel->setBounds (200, 32, 89, 24);
    antialias2x->setBounds (344, 32, 48, 24);
    antialias4x->setBounds (392, 32, 48, 24);
    antialias6x->setBounds (440, 32, 48, 24);
    fullscreenButton->setBounds (200, 64, 88, 24);
    audioLabel->setBounds (8, 104, 150, 24);
    apiLabel->setBounds (16, 136, 96, 24);
    audioApi->setBounds (120, 136, 120, 24);
    deviceLabel->setBounds (16, 168, 96, 24);
    audioDevice->setBounds (120, 168, 200, 24);
    blockSizeLabel->setBounds (16, 200, 96, 24);
    audioBlockSize->setBounds (120, 200, 88, 24);
    samplerateLabel->setBounds (336, 136, 88, 24);
    audioSamplerate->setBounds (440, 136, 120, 24);
    speakerLabel->setBounds (336, 160, 96, 32);
    audioSpeakerConfig->setBounds (440, 168, 120, 24);
    oscLabel->setBounds (16, 304, 80, 24);
    oscPort->setBounds (104, 304, 56, 24);
    disableSound->setBounds (477, 104, 112, 24);
    disableOsc->setBounds (488, 272, 104, 24);
    x3dLabel->setBounds (8, 552, 64, 24);
    loadFile->setBounds (448, 576, 32, 24);
    browserPath->setBounds (112, 432, 432, 24);
    loadPath->setBounds (552, 432, 32, 24);
    goButton->setBounds (544, 560, 48, 48);
    libsLabel->setBounds (16, 456, 72, 24);
    libraryList->setBounds (20, 480, 532, 56);
    addLibrary->setBounds (560, 480, 24, 24);
    removeLibrary->setBounds (560, 512, 23, 24);
    offlineRender->setBounds (488, 576, 54, 24);
    recordOscLabel->setBounds (16, 368, 104, 24);
    recordOscPath->setBounds (120, 368, 424, 24);
    recordOscLoad->setBounds (552, 368, 32, 24);
    fileToLoad->setBounds (20, 576, 428, 24);
    bloomFilter->setBounds (296, 64, 104, 24);
    enableCursor->setBounds (400, 64, 112, 24);
    customConfigPath->setBounds (344, 200, 200, 24);
    loadConfig->setBounds (552, 200, 32, 24);
    speakerLabel2->setBounds (216, 200, 128, 24);
    oscLabel2->setBounds (8, 272, 150, 24);
    oscInputLabel->setBounds (168, 304, 160, 24);
    oscInputAddress->setBounds (336, 304, 248, 24);
    oscOPPortLabel->setBounds (16, 336, 88, 24);
    oscOPPort->setBounds (104, 336, 56, 24);
    oscOPLabel->setBounds (168, 336, 160, 24);
    oscOPAddress->setBounds (336, 336, 248, 24);
    browserPathLabel->setBounds (8, 408, 104, 24);
    browserPathLabel2->setBounds (16, 432, 96, 24);
    inputDeviceLabel->setBounds (16, 232, 96, 24);
    audioInputDevice->setBounds (120, 232, 200, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void HeilanFrontEnd::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == antialiasOff)
    {
        //[UserButtonCode_antialiasOff] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_antialiasOff]
    }
    else if (buttonThatWasClicked == antialias2x)
    {
        //[UserButtonCode_antialias2x] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_antialias2x]
    }
    else if (buttonThatWasClicked == antialias4x)
    {
        //[UserButtonCode_antialias4x] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_antialias4x]
    }
    else if (buttonThatWasClicked == antialias6x)
    {
        //[UserButtonCode_antialias6x] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_antialias6x]
    }
    else if (buttonThatWasClicked == fullscreenButton)
    {
        //[UserButtonCode_fullscreenButton] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_fullscreenButton]
    }
    else if (buttonThatWasClicked == disableSound)
    {
        //[UserButtonCode_disableSound] -- add your button handler code here..
		if(disableSound->getToggleState())
		{
			AlertWindow::showMessageBox(AlertWindow::WarningIcon,
										T("Warning"),
										T("Certain nodes rely on sound being enabled in order to work correctly.  As well as those nodes which output sound, TimeSensor will also be disabled if this setting is selected."),
										T("ok"));
		}
		loader->changed();
        //[/UserButtonCode_disableSound]
    }
    else if (buttonThatWasClicked == disableOsc)
    {
        //[UserButtonCode_disableOsc] -- add your button handler code here..
		loader->changed();
        //[/UserButtonCode_disableOsc]
    }
    else if (buttonThatWasClicked == loadFile)
    {
        //[UserButtonCode_loadFile] -- add your button handler code here..
		FileChooser phil(T("Load X3D file..."),
						 lastX3DFile,
						 T("*.x3d"),
						 false);

		if(phil.browseForFileToOpen())
		{
			//fileToLoad->setText(phil.getResult().getFullPathName());
			fileToLoad->addItem(phil.getResult().getFullPathName(),
								fileToLoad->getNumItems()+1);
			fileToLoad->setSelectedId(fileToLoad->getNumItems());

			lastX3DFile = phil.getResult().getParentDirectory();
		}

		loader->changed();
        //[/UserButtonCode_loadFile]
    }
    else if (buttonThatWasClicked == loadPath)
    {
        //[UserButtonCode_loadPath] -- add your button handler code here..
		FileChooser phil(T("Find Heilan Browser..."),
						 File::nonexistent,
						 String::empty,
						 false);

		if(phil.browseForFileToOpen())
			browserPath->setText(phil.getResult().getFullPathName());

		loader->changed();
        //[/UserButtonCode_loadPath]
    }
    else if (buttonThatWasClicked == goButton)
    {
        //[UserButtonCode_goButton] -- add your button handler code here..
		if(fileToLoad->getText() != T(""))
			startBrowser();
        //[/UserButtonCode_goButton]
    }
    else if (buttonThatWasClicked == addLibrary)
    {
        //[UserButtonCode_addLibrary] -- add your button handler code here..
		FileChooser dlg(T("Select a library"),
						File::nonexistent,
#ifdef WIN32
						T("*.dll"),
#elif defined(OSX)
						T("*.dylib"),
#else
						T("*.so"),
#endif
						false);

		if(dlg.browseForFileToOpen())
		{
			libraries.add(dlg.getResult().getFullPathName());
			libraryList->updateContent();
		}
        //[/UserButtonCode_addLibrary]
    }
    else if (buttonThatWasClicked == removeLibrary)
    {
        //[UserButtonCode_removeLibrary] -- add your button handler code here..
		libraries.remove(libraryList->getSelectedRow());
		libraryList->updateContent();
        //[/UserButtonCode_removeLibrary]
    }
    else if (buttonThatWasClicked == offlineRender)
    {
        //[UserButtonCode_offlineRender] -- add your button handler code here..

		AlertWindow dialog(T("Offline Render Options"),
						   T(""),
						   AlertWindow::NoIcon);
		dialog.addTextEditor(T("NumSeconds"),
							 offlineSamples,
							 T("Length in seconds:"));
		dialog.addTextEditor(T("Filename"),
							 offlineFilename,
							 T("Filename:"));
		dialog.addButton(T("Cancel"), 0);
		dialog.addButton(T("OK"), 1);

		if(dialog.runModalLoop())
		{
			offlineSamples = dialog.getTextEditorContents(T("NumSeconds"));
			offlineFilename = dialog.getTextEditorContents(T("Filename"));

			startBrowser(true);
		}

        //[/UserButtonCode_offlineRender]
    }
    else if (buttonThatWasClicked == recordOscLoad)
    {
        //[UserButtonCode_recordOscLoad] -- add your button handler code here..
		FileChooser phil(T("File to record OSC events to."),
						 File::nonexistent,
						 T("*.hosc"),
						 false);

		if(phil.browseForFileToSave(true))
			recordOscPath->setText(phil.getResult().getFullPathName());
        //[/UserButtonCode_recordOscLoad]
    }
    else if (buttonThatWasClicked == bloomFilter)
    {
        //[UserButtonCode_bloomFilter] -- add your button handler code here..
        //[/UserButtonCode_bloomFilter]
    }
    else if (buttonThatWasClicked == enableCursor)
    {
        //[UserButtonCode_enableCursor] -- add your button handler code here..
        //[/UserButtonCode_enableCursor]
    }
    else if (buttonThatWasClicked == loadConfig)
    {
        //[UserButtonCode_loadConfig] -- add your button handler code here..
		FileChooser phil(T("Custom Speaker Config File."),
						 File::nonexistent,
						 T("*.xml"),
						 false);

		if(phil.browseForFileToOpen())
			customConfigPath->setText(phil.getResult().getFullPathName());
        //[/UserButtonCode_loadConfig]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}

void HeilanFrontEnd::comboBoxChanged (ComboBox* comboBoxThatHasChanged)
{
    //[UsercomboBoxChanged_Pre]
	loader->changed();
    //[/UsercomboBoxChanged_Pre]

    if (comboBoxThatHasChanged == audioApi)
    {
        //[UserComboBoxCode_audioApi] -- add your combo box handling code here..
		updateDevices();
        //[/UserComboBoxCode_audioApi]
    }
    else if (comboBoxThatHasChanged == audioDevice)
    {
        //[UserComboBoxCode_audioDevice] -- add your combo box handling code here..
        //[/UserComboBoxCode_audioDevice]
    }
    else if (comboBoxThatHasChanged == audioBlockSize)
    {
        //[UserComboBoxCode_audioBlockSize] -- add your combo box handling code here..
        //[/UserComboBoxCode_audioBlockSize]
    }
    else if (comboBoxThatHasChanged == audioSamplerate)
    {
        //[UserComboBoxCode_audioSamplerate] -- add your combo box handling code here..
        //[/UserComboBoxCode_audioSamplerate]
    }
    else if (comboBoxThatHasChanged == audioSpeakerConfig)
    {
        //[UserComboBoxCode_audioSpeakerConfig] -- add your combo box handling code here..
		if(audioSpeakerConfig->getSelectedItemIndex() == 12)
		{
			customConfigPath->setEnabled(true);
			loadConfig->setEnabled(true);
		}
		else
		{
			customConfigPath->setEnabled(false);
			loadConfig->setEnabled(false);
		}
        //[/UserComboBoxCode_audioSpeakerConfig]
    }
    else if (comboBoxThatHasChanged == fileToLoad)
    {
        //[UserComboBoxCode_fileToLoad] -- add your combo box handling code here..
        //[/UserComboBoxCode_fileToLoad]
    }
    else if (comboBoxThatHasChanged == audioInputDevice)
    {
        //[UserComboBoxCode_audioInputDevice] -- add your combo box handling code here..
        //[/UserComboBoxCode_audioInputDevice]
    }

    //[UsercomboBoxChanged_Post]
    //[/UsercomboBoxChanged_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...

//------------------------------------------------------------------------------
const StringArray HeilanFrontEnd::getMenuBarNames()
{
	StringArray retval;

	retval.add(T("File"));
	retval.add(T("Help"));

	return retval;
}

//------------------------------------------------------------------------------
const PopupMenu HeilanFrontEnd::getMenuForIndex(int topLevelMenuIndex,
												const String& menuName)
{
	PopupMenu retval;

	if(menuName == T("File"))
	{
		retval.addItem(FileOpen, T("Open"));
		retval.addSeparator();
		retval.addItem(FileSave, T("Save"));
		retval.addItem(FileSaveAs, T("Save as"));
		retval.addSeparator();
		retval.addItem(FileNew, T("Reset to defaults"));
		retval.addItem(FileSaveDefaults, T("Save as defaults"));
		retval.addSeparator();
		retval.addItem(FileQuit, T("Quit"));
	}
	else if(menuName == T("Help"))
	{
		retval.addItem(HelpAbout, T("About"));
	}

	return retval;
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::menuItemSelected(int menuItemID,
									  int topLevelMenuIndex)
{
	String tempstr;

	switch(menuItemID)
	{
		case FileNew:
			libraries.clear();
			libraryList->updateContent();
			tempstr = File::getSpecialLocation(File::userApplicationDataDirectory).getFullPathName();
			tempstr << File::separator << T("HeilanFrontEndDefaults.hfe");

			loader->loadFrom(File(tempstr), true);
			break;
		case FileOpen:
			libraries.clear();
			libraryList->updateContent();
			loader->loadFromUserSpecifiedFile(true);
			break;
		case FileSave:
			loader->save(true, true);
			break;
		case FileSaveAs:
			loader->saveAsInteractive(true);
			break;
		case FileSaveDefaults:
			tempstr = File::getSpecialLocation(File::userApplicationDataDirectory).getFullPathName();
			tempstr << File::separator << T("HeilanFrontEndDefaults.hfe");

			loader->saveAs(File(tempstr), false, false, true);
			break;
		case FileQuit:
			JUCEApplication::quit();
			break;
		case HelpAbout:
			{
				AboutBox about;
				DialogWindow::showModalDialog(T("About"),
											  &about,
											  this,
											  Colour(0xFFADD8E6),
											  false);
			}
			break;
	}
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::updateDevices()
{
	int i;
	int tempint;
	const PaHostApiInfo *apiInfo;
	const PaDeviceInfo *devInfo;
	PaDeviceIndex tempIndex;

	if(Pa_Initialize() == paNoError)
	{
		tempint = audioApi->getSelectedId()-1;
		apiInfo = Pa_GetHostApiInfo(static_cast<PaHostApiIndex>(tempint));

		if(apiInfo)
		{
			int tempStart = 0;
			audioDevice->clear();
			audioInputDevice->clear();
			for(i=0;i<apiInfo->deviceCount;i++)
			{
				tempIndex = Pa_HostApiDeviceIndexToDeviceIndex(static_cast<PaHostApiIndex>(tempint),
															   i);
				if(i == 0)
					tempStart = tempIndex;

				devInfo = Pa_GetDeviceInfo(tempIndex);
				if(devInfo->maxOutputChannels > 0)
					audioDevice->addItem(devInfo->name, (i+1));
				if(devInfo->maxInputChannels > 0)
					audioInputDevice->addItem(devInfo->name, (i+1));
			}
			if(apiInfo->deviceCount > 0)
			{
				audioDevice->setSelectedId(apiInfo->defaultOutputDevice -
										   tempStart + 1);
				audioInputDevice->setSelectedId(apiInfo->defaultInputDevice -
												tempStart + 1);
			}
		}

		Pa_Terminate();
	}
}

//------------------------------------------------------------------------------
int HeilanFrontEnd::getNumRows()
{
	return libraries.size();
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::paintListBoxItem(int rowNumber,
						  			  Graphics& g,
									  int width,
									  int height,
									  bool rowIsSelected)
{
	//Draw background first.
	if(rowIsSelected)
		g.setColour(Colours::lightblue.withSaturation(0.5f).brighter(0.75f));
	else
	{
		if(rowNumber%2)
			g.setColour(Colours::lightgrey.brighter(1.0f));
		else
			g.setColour(Colours::white);
	}
	g.fillRect(0, 0, width, height);

	//Now draw text.
	g.setColour(Colours::black);
	g.drawSingleLineText(libraries[rowNumber],
						 4,
						 (height-8));
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::paintOverChildren(Graphics& g)
{
	g.setOpacity(1.0f);
	const Colour shadowColour(0x38000000);
	g.drawBevel(20, 480, 532, 56, 3, shadowColour, shadowColour);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setWindowWidth(const String& val)
{
	windowWidth->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setWindowHeight(const String& val)
{
	windowHeight->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAntialias(int val)
{
	switch(val)
	{
		case 0:
			antialiasOff->setToggleState(true, false);
			break;
		case 1:
			antialias2x->setToggleState(true, false);
			break;
		case 2:
			antialias4x->setToggleState(true, false);
			break;
		case 3:
			antialias6x->setToggleState(true, false);
			break;
	}
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setFullscreen(bool val)
{
	fullscreenButton->setToggleState(val, false);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setBloomFilter(bool val)
{
	bloomFilter->setToggleState(val, false);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioApi(int val)
{
	audioApi->setSelectedId(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioDevice(int val)
{
	cout << val << endl;
	audioDevice->setSelectedId(val);
	cout << audioDevice->getSelectedId() << endl;
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioInputDevice(int val)
{
	cout << val << endl;
	audioInputDevice->setSelectedId(val);
	cout << audioInputDevice->getSelectedId() << endl;
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioBlockSize(int val)
{
	audioBlockSize->setSelectedId(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioSamplerate(int val)
{
	audioSamplerate->setSelectedId(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioSpeakers(int val)
{
	audioSpeakerConfig->setSelectedId(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setAudioSpeakersFile(const String& val)
{
	customConfigPath->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setOscPort(const String& val)
{
	oscPort->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setOscInputAddress(const String& val)
{
	oscInputAddress->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setOscOutputPort(const String& val)
{
	oscOPPort->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setOscOutputAddress(const String& val)
{
	oscOPAddress->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setDisableSound(bool val)
{
	disableSound->setToggleState(val, true);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setDisableOsc(bool val)
{
	disableOsc->setToggleState(val, false);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setEnableCursor(bool val)
{
	enableCursor->setToggleState(val, true);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setHeilanPath(const String& val)
{
	browserPath->setText(val);
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setFile(const String& val)
{
	fileToLoad->clear();
	fileToLoad->setText(T(""));

	//fileToLoad->setText(val);
	if(val.isNotEmpty())
	{
		fileToLoad->addItem(val, fileToLoad->getNumItems()+1);
		fileToLoad->setSelectedId(fileToLoad->getNumItems());
	}
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::addLibraryText(const String& val)
{
	libraries.add(val);
	libraryList->updateContent();
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::setRecordOscPath(const String& val)
{
	recordOscPath->setText(val);
}

//------------------------------------------------------------------------------
int HeilanFrontEnd::getAntialias() const
{
	if(antialiasOff->getToggleState())
		return 0;
	else if(antialias2x->getToggleState())
		return 1;
	else if(antialias4x->getToggleState())
		return 2;
	else
		return 3;
}

//------------------------------------------------------------------------------
void HeilanFrontEnd::startBrowser(bool offline)
{
	String args;

	//Graphics options
	args << T("-w ") << windowWidth->getText();
	args << T(" -h ") << windowHeight->getText();
	if(antialias2x->getToggleState())
		args << T(" -a 2");
	else if(antialias4x->getToggleState())
		args << T(" -a 4");
	else if(antialias6x->getToggleState())
		args << T(" -a 6");
	if(fullscreenButton->getToggleState())
		args << T(" -f");
	if(bloomFilter->getToggleState())
		args << T(" -b");
	if(enableCursor->getToggleState())
		args << T(" -c");

	//Audio options.
	args << T(" -aa ") << (audioApi->getSelectedId()-1);
	args << T(" -ad ") << (audioDevice->getSelectedId()-1);
	args << T(" -ai ") << (audioInputDevice->getSelectedId()-1);
	if(audioBlockSize->getSelectedId() > 1)
		args << T(" -ab ") << ((audioBlockSize->getSelectedId()-2)*32);
	args << T(" -as ");
	switch(audioSamplerate->getSelectedId())
	{
		case 1:
			args << T("44100.0");
			break;
		case 2:
			args << T("48000.0");
			break;
		case 3:
			args << T("96000.0");
			break;
		case 4:
			args << T("192000.0");
			break;
	}
	args << T(" -ap ") << (audioSpeakerConfig->getSelectedId()-1);
	if(audioSpeakerConfig->getSelectedItemIndex() == 12)
		args << T(" ") << customConfigPath->getText();

	//Other options.
	args << T(" -op ") << oscPort->getText();
	if(oscInputAddress->getText() != String::empty)
		args << T(" -om ") << oscInputAddress->getText();
	args << T(" -oop ") << oscOPPort->getText();
	if(oscOPAddress->getText() != String::empty)
		args << T(" -ooa ") << oscOPAddress->getText();

	if(disableSound->getToggleState())
		args << T(" -na");
	if(disableOsc->getToggleState())
		args << T(" -nO");

	for(int i=0;i<libraries.size();++i)
		args << T(" -l \"") << libraries[i] << T("\"");

	if(offline)
		args << T(" -of ") << offlineSamples << T(" \"") << offlineFilename << T("\"");

	if(!recordOscPath->getText().isEmpty())
		args << T(" -rO \"") << recordOscPath->getText() << "\"";

	//File to load.
	args << T(" \"") << fileToLoad->getText() << "\"";

	File phil(browserPath->getText());
	cout << "\"" << (const char *)(browserPath->getText()) << "\" " << (const char *)args << endl;
#ifdef WIN32
	phil.startAsProcess(args);
#else
	juce_launchFile2(browserPath->getText(), args);
#endif
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="HeilanFrontEnd" componentName="Heilan Front End"
                 parentClasses="public Component, public MenuBarModel, public ListBoxModel"
                 constructorParams="" variableInitialisers="" snapPixels="8" snapActive="1"
                 snapShown="1" overlayOpacity="0" fixedSize="1" initialWidth="600"
                 initialHeight="616">
  <BACKGROUND backgroundColour="ffadd8e6">
    <RECT pos="8 96 584 1" fill="solid: ff000000" hasStroke="0"/>
    <RECT pos="8 264 584 1" fill="solid: ff000000" hasStroke="0"/>
    <RECT pos="8 400 584 1" fill="solid: ff000000" hasStroke="0"/>
    <RECT pos="8 545 584 1" fill="solid: ff000000" hasStroke="0"/>
  </BACKGROUND>
  <TEXTEDITOR name="Window Width" id="e2d2f8b90cec159c" memberName="windowWidth"
              virtualName="" explicitFocusOrder="0" pos="120 32 48 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="640" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <LABEL name="new label" id="fd0452243e9c65ba" memberName="widthLabel"
         virtualName="" explicitFocusOrder="0" pos="16 32 104 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Window Width:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <LABEL name="new label" id="43f8bca38363b745" memberName="graphicsLabel"
         virtualName="" explicitFocusOrder="0" pos="8 0 150 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Graphics Options" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="1" italic="0" justification="33"/>
  <TEXTEDITOR name="Window Height" id="522766a9e21b8c19" memberName="windowHeight"
              virtualName="" explicitFocusOrder="0" pos="120 64 48 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="480" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <LABEL name="new label" id="aaa1ab12a1c1dcf" memberName="heightLabel"
         virtualName="" explicitFocusOrder="0" pos="16 64 104 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Window Height:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTBUTTON name="off" id="a7305d2f628a0d0a" memberName="antialiasOff" virtualName=""
              explicitFocusOrder="0" pos="296 32 48 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="off" connectedEdges="2"
              needsCallback="1" radioGroupId="0"/>
  <LABEL name="new label" id="1d8e34877447f2d4" memberName="antialiasLabel"
         virtualName="" explicitFocusOrder="0" pos="200 32 89 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Antialiasing:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTBUTTON name="2x" id="cea7df154854fb93" memberName="antialias2x" virtualName=""
              explicitFocusOrder="0" pos="344 32 48 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="2x" connectedEdges="3"
              needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="4x" id="56a7ae83d0a3c526" memberName="antialias4x" virtualName=""
              explicitFocusOrder="0" pos="392 32 48 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="4x" connectedEdges="3"
              needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="6x" id="adf285069544b61f" memberName="antialias6x" virtualName=""
              explicitFocusOrder="0" pos="440 32 48 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="6x" connectedEdges="1"
              needsCallback="1" radioGroupId="0"/>
  <TOGGLEBUTTON name="Fullscreen" id="f17f5833c7e7fa39" memberName="fullscreenButton"
                virtualName="" explicitFocusOrder="0" pos="200 64 88 24" buttonText="Fullscreen"
                connectedEdges="0" needsCallback="1" radioGroupId="0" state="0"/>
  <LABEL name="new label" id="d2e4768f8a26d081" memberName="audioLabel"
         virtualName="" explicitFocusOrder="0" pos="8 104 150 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Audio Options" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="1" italic="0" justification="33"/>
  <LABEL name="new label" id="906c6807441df1c2" memberName="apiLabel"
         virtualName="" explicitFocusOrder="0" pos="16 136 96 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Audio API:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="6436eef1e99e1a38" memberName="audioApi"
            virtualName="" explicitFocusOrder="0" pos="120 136 120 24" editable="0"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="53783e4741b13f9b" memberName="deviceLabel"
         virtualName="" explicitFocusOrder="0" pos="16 168 96 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Output Device:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="1610bb3849f644f4" memberName="audioDevice"
            virtualName="" explicitFocusOrder="0" pos="120 168 200 24" editable="0"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="d0c6e346e5401fe9" memberName="blockSizeLabel"
         virtualName="" explicitFocusOrder="0" pos="16 200 96 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Block Size:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="550058b09acef58" memberName="audioBlockSize"
            virtualName="" explicitFocusOrder="0" pos="120 200 88 24" editable="0"
            layout="33" items="default" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="374cb4d8fbbc8980" memberName="samplerateLabel"
         virtualName="" explicitFocusOrder="0" pos="336 136 88 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Samplerate:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="a85501c65d3a1802" memberName="audioSamplerate"
            virtualName="" explicitFocusOrder="0" pos="440 136 120 24" editable="0"
            layout="33" items="44100&#10;48000&#10;96000&#10;192000" textWhenNonSelected=""
            textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="c42cf70067a18285" memberName="speakerLabel"
         virtualName="" explicitFocusOrder="0" pos="336 160 96 32" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Speaker&#10;Configuration:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="77f24f453cbe3cc7" memberName="audioSpeakerConfig"
            virtualName="" explicitFocusOrder="0" pos="440 168 120 24" editable="0"
            layout="33" items="Mono&#10;Stereo&#10;Square&#10;Pentagon&#10;Hexagon&#10;Octagon1&#10;Octagon2&#10;Surround1&#10;Cube&#10;Dodecahedron1&#10;Dodecahedron2&#10;Components&#10;Custom"
            textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="b8212402c5dcaa42" memberName="oscLabel"
         virtualName="" explicitFocusOrder="0" pos="16 304 80 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Input Port:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="OSC Port" id="451cd727a015b3a4" memberName="oscPort" virtualName=""
              explicitFocusOrder="0" pos="104 304 56 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="5678" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <TOGGLEBUTTON name="Disable Sound" id="5b6494e2c56cbf90" memberName="disableSound"
                virtualName="" explicitFocusOrder="0" pos="477 104 112 24" buttonText="Disable Sound"
                connectedEdges="0" needsCallback="1" radioGroupId="0" state="0"/>
  <TOGGLEBUTTON name="Disable OSC" id="2d3ad0053e456de9" memberName="disableOsc"
                virtualName="" explicitFocusOrder="0" pos="488 272 104 24" buttonText="Disable OSC"
                connectedEdges="0" needsCallback="1" radioGroupId="0" state="0"/>
  <LABEL name="new label" id="6ea88f4b66152a54" memberName="x3dLabel"
         virtualName="" explicitFocusOrder="0" pos="8 552 64 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="X3D File" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="1" italic="0" justification="33"/>
  <TEXTBUTTON name="..." id="13900762747cf4f9" memberName="loadFile" virtualName=""
              explicitFocusOrder="0" pos="448 576 32 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="..." connectedEdges="1"
              needsCallback="1" radioGroupId="0"/>
  <TEXTEDITOR name="new text editor" id="79808490ce0bf7f2" memberName="browserPath"
              virtualName="" explicitFocusOrder="0" pos="112 432 432 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <TEXTBUTTON name="..." id="161a3120089d157" memberName="loadPath" virtualName=""
              explicitFocusOrder="0" pos="552 432 32 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="..." connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="go" id="6bea1d8bf02c0059" memberName="goButton" virtualName=""
              explicitFocusOrder="0" pos="544 560 48 48" bgColOff="ff00a60f"
              bgColOn="ff096f12" textCol="ff000000" buttonText="Go" connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <LABEL name="new label" id="124e9977d1f7b12d" memberName="libsLabel"
         virtualName="" explicitFocusOrder="0" pos="16 456 72 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Libraries:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <GENERICCOMPONENT name="Library List" id="4ea1ee71aeae8686" memberName="libraryList"
                    virtualName="" explicitFocusOrder="0" pos="20 480 532 56" class="ListBox"
                    params="T(&quot;Library List&quot;), this"/>
  <TEXTBUTTON name="Add Library Button" id="37a25f5cbecd2f71" memberName="addLibrary"
              virtualName="" explicitFocusOrder="0" pos="560 480 24 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="+" connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="Remove Library Button" id="630d5431024d6840" memberName="removeLibrary"
              virtualName="" explicitFocusOrder="0" pos="560 512 23 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="-" connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="Offline" id="1e04f01a181d8f6d" memberName="offlineRender"
              virtualName="" explicitFocusOrder="0" pos="488 576 54 24" bgColOff="ffff4747"
              bgColOn="ff9e2a2a" buttonText="Offline" connectedEdges="0" needsCallback="1"
              radioGroupId="0"/>
  <LABEL name="recordOscLabel" id="40435e83e039a5a3" memberName="recordOscLabel"
         virtualName="" explicitFocusOrder="0" pos="16 368 104 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Record OSC to:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="recordOscPath" id="acb46343e888884b" memberName="recordOscPath"
              virtualName="" explicitFocusOrder="0" pos="120 368 424 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <TEXTBUTTON name="..." id="387eed17f5de884a" memberName="recordOscLoad" virtualName=""
              explicitFocusOrder="0" pos="552 368 32 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="..." connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <COMBOBOX name="new combo box" id="99f6eef7944cbadb" memberName="fileToLoad"
            virtualName="" explicitFocusOrder="0" pos="20 576 428 24" editable="1"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <TOGGLEBUTTON name="bloomFilter" id="7fa3b75ade53f92" memberName="bloomFilter"
                virtualName="" explicitFocusOrder="0" pos="296 64 104 24" buttonText="Bloom Filter"
                connectedEdges="0" needsCallback="1" radioGroupId="0" state="0"/>
  <TOGGLEBUTTON name="Enable Cursor" id="8ac99746d27f0ef7" memberName="enableCursor"
                virtualName="" explicitFocusOrder="0" pos="400 64 112 24" buttonText="Enable Cursor"
                connectedEdges="0" needsCallback="1" radioGroupId="0" state="0"/>
  <TEXTEDITOR name="new text editor" id="e56426fe1f379bda" memberName="customConfigPath"
              virtualName="" explicitFocusOrder="0" pos="344 200 200 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <TEXTBUTTON name="..." id="15b40694ef20c210" memberName="loadConfig" virtualName=""
              explicitFocusOrder="0" pos="552 200 32 24" bgColOff="ffbbbbff"
              bgColOn="ff4444ff" textCol="ff000000" buttonText="..." connectedEdges="0"
              needsCallback="1" radioGroupId="0"/>
  <LABEL name="new label" id="4532b547efe0f5f" memberName="speakerLabel2"
         virtualName="" explicitFocusOrder="0" pos="216 200 128 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Speaker Config File:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <LABEL name="new label" id="79fb0d50f12c2e68" memberName="oscLabel2"
         virtualName="" explicitFocusOrder="0" pos="8 272 150 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="OSC Options" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="1" italic="0" justification="33"/>
  <LABEL name="new label" id="71945c25adf056b0" memberName="oscInputLabel"
         virtualName="" explicitFocusOrder="0" pos="168 304 160 24" edTextCol="ff000000"
         edBkgCol="0" labelText="Multicast Input Address:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="new text editor" id="d3b9b5663ac718b3" memberName="oscInputAddress"
              virtualName="" explicitFocusOrder="0" pos="336 304 248 24" initialText=""
              multiline="0" retKeyStartsLine="0" readonly="0" scrollbars="1"
              caret="1" popupmenu="1"/>
  <LABEL name="new label" id="135650eb72e51175" memberName="oscOPPortLabel"
         virtualName="" explicitFocusOrder="0" pos="16 336 88 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Output Port:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="OSC Port" id="8aef05309ce18929" memberName="oscOPPort"
              virtualName="" explicitFocusOrder="0" pos="104 336 56 24" textcol="ff000000"
              bkgcol="ffffffff" hilitecol="401111ee" outlinecol="0" shadowcol="38000000"
              caretcol="ff000000" initialText="5679" multiline="0" retKeyStartsLine="0"
              readonly="0" scrollbars="1" caret="1" popupmenu="1"/>
  <LABEL name="new label" id="6939940e24411d3e" memberName="oscOPLabel"
         virtualName="" explicitFocusOrder="0" pos="168 336 160 24" edTextCol="ff000000"
         edBkgCol="0" labelText="Output Address:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="new text editor" id="f453a4d4161fa461" memberName="oscOPAddress"
              virtualName="" explicitFocusOrder="0" pos="336 336 248 24" initialText=""
              multiline="0" retKeyStartsLine="0" readonly="0" scrollbars="1"
              caret="1" popupmenu="1"/>
  <LABEL name="new label" id="e0be506ec73e45da" memberName="browserPathLabel"
         virtualName="" explicitFocusOrder="0" pos="8 408 104 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Files" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="1" italic="0" justification="33"/>
  <LABEL name="new label" id="d77f8bb902b3e1ab" memberName="browserPathLabel2"
         virtualName="" explicitFocusOrder="0" pos="16 432 96 24" edTextCol="ff000000"
         edBkgCol="0" labelText="Browser Path:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <LABEL name="new label" id="f3ec1e93a19c570" memberName="inputDeviceLabel"
         virtualName="" explicitFocusOrder="0" pos="16 232 96 24" bkgCol="0"
         textCol="ff000000" outlineCol="0" edTextCol="ff000000" edBkgCol="0"
         hiliteCol="401111ee" labelText="Input Device:" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <COMBOBOX name="new combo box" id="8a470dd844aa6091" memberName="audioInputDevice"
            virtualName="" explicitFocusOrder="0" pos="120 232 200 24" editable="0"
            layout="33" items="" textWhenNonSelected="" textWhenNoItems="(no choices)"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
