/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  11 Feb 2009 10:48:00 am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.11

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

#ifndef __JUCER_HEADER_HEILANFRONTEND_WINDOW_99FCC842__
#define __JUCER_HEADER_HEILANFRONTEND_WINDOW_99FCC842__

//[Headers]     -- You can add your own extra header files here --
class FileLoader;
//[/Headers]



//==============================================================================
/**
                                                                    //[Comments]
                                                                    //[/Comments]
*/
class HeilanFrontEnd  : public Component,
                        public MenuBarModel,
                        public ListBoxModel,
                        public ButtonListener,
                        public ComboBoxListener
{
public:
    //==============================================================================
    HeilanFrontEnd ();
    ~HeilanFrontEnd();

    //==============================================================================
    //[UserMethods]     -- You can add your own custom methods in this section.

	///	Returns the names of the various menu groups.
	const StringArray getMenuBarNames();
	///	Returns the menu for a particular menu group.
	const PopupMenu getMenuForIndex(int topLevelMenuIndex,
								    const String& menuName);
	///	Called when a menu item is selected.
	void menuItemSelected(int menuItemID,
						  int topLevelMenuIndex);

	///	So we get informed when the audio API changes.
	//void comboBoxChanged(ComboBox *box);

	///	Updates the audioDevice ComboBox when audioApi changes.
	void updateDevices();

	///	Returns the number of rows in the list box.
	int getNumRows();
	///	Draws the contents of the list box.
	void paintListBoxItem(int rowNumber,
						  Graphics& g,
						  int width,
						  int height,
						  bool rowIsSelected);

	///	Draws an outline for the list box.
	void paintOverChildren(Graphics& g);

	void setWindowWidth(const String& val);
	void setWindowHeight(const String& val);
	void setAntialias(int val);
	void setFullscreen(bool val);
	void setBloomFilter(bool val);
	void setAudioApi(int val);
	void setAudioDevice(int val);
	void setAudioInputDevice(int val);
	void setAudioBlockSize(int val);
	void setAudioSamplerate(int val);
	void setAudioSpeakers(int val);
	void setAudioSpeakersFile(const String& val);
	void setOscPort(const String& val);
	void setOscInputAddress(const String& val);
	void setOscOutputPort(const String& val);
	void setOscOutputAddress(const String& val);
	void setDisableSound(bool val);
	void setDisableOsc(bool val);
	void setHeilanPath(const String& val);
	void setFile(const String& val);
	void addLibraryText(const String& val);
	void setRecordOscPath(const String& val);
	void setEnableCursor(bool val);

	const String getWindowWidth() const {return windowWidth->getText();};
	const String getWindowHeight() const {return windowHeight->getText();};
	int getAntialias() const;
	bool getFullscreen() const {return fullscreenButton->getToggleState();};
	bool getBloomFilter() const {return bloomFilter->getToggleState();};
	int getAudioApi() const {return audioApi->getSelectedId();};
	int getAudioDevice() const {return audioDevice->getSelectedId();};
	int getAudioInputDevice() const {return audioInputDevice->getSelectedId();};
	int getAudioBlockSize() const {return audioBlockSize->getSelectedId();};
	int getAudioSamplerate() const {return audioSamplerate->getSelectedId();};
	int getAudioSpeakers() const {return audioSpeakerConfig->getSelectedId();};
	const String getAudioSpeakersFile() const {return customConfigPath->getText();};
	const String getOscPort() const {return oscPort->getText();};
	const String getOscInputAddress() const {return oscInputAddress->getText();};
	const String getOscOutputPort() const {return oscOPPort->getText();};
	const String getOscOutputAddress() const {return oscOPAddress->getText();};
	bool getDisableSound() const {return disableSound->getToggleState();};
	bool getDisableOsc() const {return disableOsc->getToggleState();};
	const String getHeilanPath() const {return browserPath->getText();};
	const String getFile() const {return fileToLoad->getText();};
	int getNumLibraries() const {return libraries.size();};
	const String& getLibrary(int index) {return libraries[index];};
	const String getRecordOscPath() const {return recordOscPath->getText();};
	bool getEnableCursor() const {return enableCursor->getToggleState();};


	///	Starts HeilanBrowser.
	void startBrowser(bool offline = false);

    //[/UserMethods]

    void paint (Graphics& g);
    void resized();
    void buttonClicked (Button* buttonThatWasClicked);
    void comboBoxChanged (ComboBox* comboBoxThatHasChanged);


    //==============================================================================
    juce_UseDebuggingNewOperator

private:
    //[UserVariables]   -- You can add your own custom variables in this section.
	///	Enum used to enumerate the various menu IDs.
	enum
	{
		FileNew = 1,
		FileOpen,
		FileSave,
		FileSaveAs,
		FileSaveDefaults,
		FileQuit,
		HelpAbout,
		SlotId
	};

	///	Pointer to our FileLoader for loading and saving files.
	FileLoader *loader;

	///	Our list of libraries to load.
	StringArray libraries;

	///	We store the last used number of samples for the offline render dialog.
	String offlineSamples;
	///	We store the last used file name for the offline render dialog.
	String offlineFilename;

	///	The last directory used in the fileToLoad TextEditor.
	File lastX3DFile;
    //[/UserVariables]

    //==============================================================================
    TextEditor* windowWidth;
    Label* widthLabel;
    Label* graphicsLabel;
    TextEditor* windowHeight;
    Label* heightLabel;
    TextButton* antialiasOff;
    Label* antialiasLabel;
    TextButton* antialias2x;
    TextButton* antialias4x;
    TextButton* antialias6x;
    ToggleButton* fullscreenButton;
    Label* audioLabel;
    Label* apiLabel;
    ComboBox* audioApi;
    Label* deviceLabel;
    ComboBox* audioDevice;
    Label* blockSizeLabel;
    ComboBox* audioBlockSize;
    Label* samplerateLabel;
    ComboBox* audioSamplerate;
    Label* speakerLabel;
    ComboBox* audioSpeakerConfig;
    Label* oscLabel;
    TextEditor* oscPort;
    ToggleButton* disableSound;
    ToggleButton* disableOsc;
    Label* x3dLabel;
    TextButton* loadFile;
    TextEditor* browserPath;
    TextButton* loadPath;
    TextButton* goButton;
    Label* libsLabel;
    ListBox* libraryList;
    TextButton* addLibrary;
    TextButton* removeLibrary;
    TextButton* offlineRender;
    Label* recordOscLabel;
    TextEditor* recordOscPath;
    TextButton* recordOscLoad;
    ComboBox* fileToLoad;
    ToggleButton* bloomFilter;
    ToggleButton* enableCursor;
    TextEditor* customConfigPath;
    TextButton* loadConfig;
    Label* speakerLabel2;
    Label* oscLabel2;
    Label* oscInputLabel;
    TextEditor* oscInputAddress;
    Label* oscOPPortLabel;
    TextEditor* oscOPPort;
    Label* oscOPLabel;
    TextEditor* oscOPAddress;
    Label* browserPathLabel;
    Label* browserPathLabel2;
    Label* inputDeviceLabel;
    ComboBox* audioInputDevice;

    //==============================================================================
    // (prevent copy constructor and operator= being generated..)
    HeilanFrontEnd (const HeilanFrontEnd&);
    const HeilanFrontEnd& operator= (const HeilanFrontEnd&);
};


#endif   // __JUCER_HEADER_HEILANFRONTEND_WINDOW_99FCC842__
